<?php

namespace App\Controller;

use App\Entity\Skill;
use App\Form\SkillType;
use App\Repository\SkillRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

class SkillController extends AbstractController
{
    public function __construct(
        private readonly EntityManagerInterface $entityManager,
        private readonly SkillRepository        $skillRepository
    )
    {
    }

    #[Route('/skill/add', name: 'skill_add')]
    public function add(Request $request): Response
    {
        $skill = new Skill();
        $form = $this->createForm(SkillType::class, $skill);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->entityManager->persist($skill);
            $this->entityManager->flush();
        }

        return $this->render('skill/add.html.twig', [
            'form' => $form,
        ]);
    }

    #[Route('/skill/list', name: 'skill_list')]
    public function list(): Response
    {
        $skills = $this->skillRepository->findAll();

        return $this->render('skill/list.html.twig', [
            'skills' => $skills,
        ]);
    }

}